package com.tzld.piaoquan.recommend.feature.grpcservice;

import com.tzld.piaoquan.recommend.feature.model.feature.*;
import com.tzld.piaoquan.recommend.feature.service.UserFeatureService;
import com.tzld.piaoquan.recommend.feature.service.VideoFeatureService;
import io.grpc.stub.StreamObserver;
import net.devh.boot.grpc.server.service.GrpcService;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * @author dyp
 */
@GrpcService
public class FeatureGrpcService extends FeatureServiceGrpc.FeatureServiceImplBase {
    @Autowired
    private UserFeatureService userFeatureService;
    @Autowired
    private VideoFeatureService videoFeatureService;

    @Override
    public void getUserFeature(GetUserFeatureRequest request, StreamObserver<GetUserFeatureResponse> responseObserver) {
        GetUserFeatureResponse response = userFeatureService.getUserFeature(request);
        responseObserver.onNext(response);
        responseObserver.onCompleted();
    }

    @Override
    public void getVideoFeature(GetVideoFeatureRequest request,
                                StreamObserver<GetVideoFeatureResponse> responseObserver) {
        GetVideoFeatureResponse response = videoFeatureService.getVideoFeature(request);
        responseObserver.onNext(response);
        responseObserver.onCompleted();
    }

    @Override
    public void getAllVideoFeature(GetAllVideoFeatureRequest request,
                                   StreamObserver<GetAllVideoFeatureResponse> responseObserver) {
        GetAllVideoFeatureResponse response = videoFeatureService.getAllVideoFeature(request);
        responseObserver.onNext(response);
        responseObserver.onCompleted();
    }
}
